/*
 * CS 106X, Nick Troccoli
 * This header declares various useful functions on trees.
 * See treefunctions.cpp for the implementation of the functions.
 */

#pragma once

#include <iostream>
#include "TreeNode.h"

/*
 * Outputs all nodes of the tree with the given node as its root to the
 * output stream, in in-order traversal.
 */
void print(TreeNode *node, std::ostream& out);

/*
 * Returns the number of nodes in the given tree.
 */
int size(TreeNode *node);

/*
 * Returns true if the given tree contains the given value.
 */
bool contains(TreeNode *node, int value);

/*
 * Returns the given tree's height.
 * The height of an empty tree is defined to be 0.
 * An unempty tree's height is the length of the longest path from the root
 * node to any other node in the tree.
 */
int height(TreeNode *node);

/*
 * Deletes all memory associated with the tree at the given root.
 */
void deleteTree(TreeNode *node);

